package ApplyingTemplate;

import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Frame;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import quadbase.reportdesigner.ReportAPI.DBInfo;
import quadbase.reportdesigner.ReportAPI.QbReport;
import quadbase.reportdesigner.ReportViewer.Viewer;
import quadbase.reportdesigner.util.ColInfo;

public class ApplyingTemplate extends Applet {

	static final long serialVersionUID = 1;

	public static void main(String[] args) {
		try {
			ApplyingTemplate report = new ApplyingTemplate();
			Frame frame = new Frame();
			frame.setLayout(new BorderLayout());
			frame.add("Center", report.doApplyingTemplate(frame));
			frame.addWindowListener(new WindowAdapter() {
				public void windowClosing(WindowEvent e) {
					System.exit(0);
				}
			});
			frame.setSize(800, 600);
			frame.setVisible(true);

		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}

	public void init() {
		setLayout(new BorderLayout());
		add("Center", doApplyingTemplate(this));
	}

	Component doApplyingTemplate(Object parent)  {
		
		// Do not use EspressManager
		QbReport.setEspressManagerUsed(false);
		
		// Template Location
		String templateLocation = "ApplyingTemplate.rpt";
		
		// Data Source
		DBInfo databaseInfo = new DBInfo("jdbc:hsqldb:woodview", 
										 "org.hsqldb.jdbcDriver", 
										 "sa", "", 
										 "SELECT Categories.CategoryName, Products.ProductName, Products.UnitPrice, Products.StainPrice, Products.UnitsInStock FROM Products, Categories WHERE (Products.CategoryID = Categories.CategoryID)");
		
		// Column Mapping
		ColInfo[] columnMapping = new ColInfo[5];
		for (int i = 0; i < columnMapping.length; i++)
		{
			columnMapping[i] = new ColInfo(i);
			if (i == 0) {
				columnMapping[i].setRowBreak(true);
			} else {
				columnMapping[i].setAggregation(false, ColInfo.NONE);
			}
		}
										
		// Apply the template
		QbReport report = new QbReport (parent,          										// container 
						   	  			QbReport.SUMMARY,										// report type
						   	  			databaseInfo,											// data
						   	  			columnMapping,											// column mapping
						   	  			templateLocation);										// template
	
		// Show report in Viewer
		return (new Viewer().getComponent(report));
	}
}
